<template>
    <span>
        <error-boundary>
            <span v-if="days <= '0' &&  hours <= '0' && minutes <= '0' && seconds <= '0'">0s
            </span>
            <span v-else>{{ Math.trunc(hours) | two_digits }}h {{ Math.trunc(minutes) | two_digits }}min {{ Math.trunc(seconds) | two_digits }}s
            </span>
        </error-boundary>
    </span>
</template>

<script>
    import {mapActions} from "vuex"
    import ErrorBoundary from "./ErrorBoundary";

    export default {
        components: {ErrorBoundary},
        props: {
            date: {
                type: Date
            }
        },
        data() {
            return {
                now: 0,
                count: 0,
            }
        },
        methods: {
            ...mapActions(["logout"]),
            timer_loop() {
                this.count++
                this.now = Math.trunc(new Date().getTime() / 1000)
                //console.log(this.now);
                this.count < 200 && setTimeout(this.timer_loop, 1000)
            },
        },
        mounted() {
            this.timer_loop()
        },
        computed: {
            seconds() {
                return (this.modifiedDate - this.now) % 60
            },
            minutes() {
                return ((this.modifiedDate - this.now) / 60) % 60
            },
            hours() {
                return ((this.modifiedDate - this.now) / 60 / 60) % 24
            },
            days() {
                return ((this.modifiedDate - this.now) / 60 / 60 / 24)
            },
            modifiedDate: function () {
                return Math.trunc(Date.parse(this.date) / 1000)
            }
        }
    }
</script>

<style>
</style>